Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_intra_main.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_intra_main.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_intra_main.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_intra_main10.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_intra_main10.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_intra_main10.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main10
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_P_main.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_P_main.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_P_main.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_P_main10.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_P_main10.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_P_main10.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main10
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_main.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_main.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_main.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_main10.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_main10.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_lowdelay_main10.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main10
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_randomaccess_main.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_randomaccess_main.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_randomaccess_main.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_randomaccess_main10.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_randomaccess_main10.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/encoder_randomaccess_main10.cfg	(revision 651)
@@ -3,7 +3,6 @@
 ReconFile                     : rec.yuv
 
-#======== Profile/Level ================
+#======== Profile ================
 Profile                       : main10
-Level                         : 6.2
 
 #======== Unit definition ================
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQMall.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQMall.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQMall.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 480         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 3.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQSquare.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQSquare.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQSquare.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 240         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 2.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQTerrace.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQTerrace.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BQTerrace.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1080        # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 4.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrill.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrill.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrill.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 480         # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 3.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrillText.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrillText.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrillText.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 480         # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 3.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrive.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrive.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballDrive.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1080        # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 4.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballPass.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballPass.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BasketballPass.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 240         # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 2.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BlowingBubbles.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BlowingBubbles.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/BlowingBubbles.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 240         # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 2.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Cactus.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Cactus.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Cactus.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1080        # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 4.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/ChinaSpeed.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/ChinaSpeed.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/ChinaSpeed.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 768         # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 3.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/FourPeople.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/FourPeople.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/FourPeople.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 4
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Johnny.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Johnny.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Johnny.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 4
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Kimono.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Kimono.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Kimono.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1080        # Input  frame height
 FramesToBeEncoded              : 240         # Number of frames to be coded
+
+Level                         : 4.0
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/KristenAndSara.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/KristenAndSara.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/KristenAndSara.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 4
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/NebutaFestival_10bit.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/NebutaFestival_10bit.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/NebutaFestival_10bit.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1600        # Input  frame height
 FramesToBeEncoded              : 300         # Number of frames to be coded
+
+Level                         : 5
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/ParkScene.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/ParkScene.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/ParkScene.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1080        # Input  frame height
 FramesToBeEncoded              : 240         # Number of frames to be coded
+
+Level                         : 4.0
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/PartyScene.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/PartyScene.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/PartyScene.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 480         # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 3.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/PeopleOnStreet.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/PeopleOnStreet.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/PeopleOnStreet.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1600        # Input  frame height
 FramesToBeEncoded              : 150         # Number of frames to be coded
+
+Level                         : 5
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/RaceHorses.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/RaceHorses.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/RaceHorses.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 240         # Input  frame height
 FramesToBeEncoded              : 300         # Number of frames to be coded
+
+Level                         : 2
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/RaceHorsesC.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/RaceHorsesC.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/RaceHorsesC.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 480         # Input  frame height
 FramesToBeEncoded              : 300         # Number of frames to be coded
+
+Level                         : 3
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SlideEditing.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SlideEditing.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SlideEditing.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 300         # Number of frames to be coded
+
+Level                         : 3.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SlideShow.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SlideShow.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SlideShow.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 500         # Number of frames to be coded
+
+Level                         : 3.1
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SteamLocomotiveTrain_10bit.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SteamLocomotiveTrain_10bit.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/SteamLocomotiveTrain_10bit.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1600        # Input  frame height
 FramesToBeEncoded              : 300         # Number of frames to be coded
+
+Level                         : 5
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Traffic.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Traffic.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Traffic.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 1600        # Input  frame height
 FramesToBeEncoded              : 150         # Number of frames to be coded
+
+Level                         : 5
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo1.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo1.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo1.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 4
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo3.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo3.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo3.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 4
Index: branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo4.cfg
===================================================================
--- branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo4.cfg	(revision 645)
+++ branches/HTM-8.2-dev0-Cleanup/cfg/HEVC/HM/per-sequence/Vidyo4.cfg	(revision 651)
@@ -7,2 +7,4 @@
 SourceHeight                  : 720         # Input  frame height
 FramesToBeEncoded              : 600         # Number of frames to be coded
+
+Level                         : 4